//+------------------------------------------------------------------+
//|                                                 Hourly_HI_LO.mq4 |
//|                      Copyright  2006, MetaQuotes Software Corp. |
//|                                        http://www.metaquotes.net |
//+------------------------------------------------------------------+
#property copyright "Copyright  2006, MetaQuotes Software Corp."
#property link      "http://www.metaquotes.net"

#property indicator_chart_window

#define CURH "CURH"
extern bool Display_Rectangle_or_Line = true;
extern int Line_Width = 3;
extern int Color_1 = Red;

extern bool Display_Prev_Hour = true;
#define PREH "PREH"
extern bool Display_Rectangle2_or_Line = true;
extern int Line_Width2 = 3;
extern int Color_2 = Blue;

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- indicators
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   ObjectsDeleteAll(0,OBJ_LABEL);
   
 ObjectDelete (CURH);ObjectDelete (PREH);
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
   int    counted_bars=IndicatorCounted();
   
   
   CreateCH();
}


void CreateCurrentHour(string HiLow, double start, double end, color clr)
  {
   ObjectCreate(HiLow, OBJ_RECTANGLE, 0, iTime(NULL,60,0), start, Time[0], end);
   ObjectSet(HiLow, OBJPROP_COLOR, clr);
   ObjectSet(HiLow,OBJPROP_BACK,Display_Rectangle_or_Line);
   ObjectSet(HiLow,OBJPROP_WIDTH ,Line_Width );
   ObjectSet(HiLow,OBJPROP_STYLE,0);
   }
   void DeleteCreateCurrentHour()
   {
   ObjectDelete (CURH);
      }
   void CreateCH()
   {
   DeleteCreateCurrentHour();
   
   
   CreatePH();
}


void CreatePreviousHour(string HiLow2, double start, double end, color clr)
  {
   ObjectCreate(HiLow2, OBJ_RECTANGLE, 0, iTime(NULL,60,1), start, Time[0], end);
   ObjectSet(HiLow2, OBJPROP_COLOR, clr);
   ObjectSet(HiLow2,OBJPROP_BACK,Display_Rectangle2_or_Line);
   ObjectSet(HiLow2,OBJPROP_WIDTH, Line_Width2 );
   ObjectSet(HiLow2,OBJPROP_STYLE,0);
   }
   void DeleteCreatePreviousHour()
   {
  ObjectDelete  (PREH);
      }
   void CreatePH()
   {
   DeleteCreatePreviousHour();

  
   double HI = iHigh(NULL,60,0);
   double LOW = iLow(NULL,60,0); 
 
   double HI2 = iHigh(NULL,60,1);
   double LOW2 = iLow(NULL,60,1); 
     
       string HHi,HLo,HHi2,HLo2; 

	 
       HHi = (DoubleToStr (HI2,Digits));
	    HLo = (DoubleToStr(LOW2,Digits));
	    HHi2 = (DoubleToStr (HI,Digits));//added to show current price
	    HLo2 = (DoubleToStr(LOW,Digits));//added to show current price
   
   
   CreateCurrentHour(CURH,HI,LOW, Color_1);
   
   if (Display_Prev_Hour == true)
   {
   CreatePreviousHour(PREH, HI2, LOW2, Color_2 );
  }
      ObjectsRedraw();

//----
       ObjectDelete("HILO");
       HILO( "HILO", 20, 12,4);
       ObjectSetText( "HILO", "Cur High ", 9, "Arial Bold", SkyBlue );
       ObjectDelete("HILO1");
       HILO1( "HILO1", 20, 12,4);
       ObjectSetText( "HILO1", ""+HHi2+"", 12, "Arial Bold", Orange );
       
        ObjectDelete("HILO2");
       HILO2( "HILO2", 40, 12,4);
       ObjectSetText( "HILO2", "Cur Low ", 9, "Arial Bold", SkyBlue );
       ObjectDelete("HILO3");
       HILO3( "HILO3", 40, 12,4);
       ObjectSetText( "HILO3", ""+HLo2+""  , 12, "Arial Bold", Orange );
       
        if (Display_Prev_Hour == true)
   {
        ObjectDelete("HILO4");
       HILO4( "HILO4", 60, 12,4);
       ObjectSetText( "HILO4", "Prev High ", 9, "Arial", SkyBlue );
       ObjectDelete("HILO5");
       HILO5( "HILO5", 60, 12,4);
       ObjectSetText( "HILO5", ""+HHi+"", 12, "Arial Bold", Silver );
       
        ObjectDelete("HILO6");
       HILO6( "HILO6", 80, 12,4);
       ObjectSetText( "HILO6", "Prev Low ", 9, "Arial", SkyBlue );
       ObjectDelete("HILO7");
       HILO7( "HILO7", 80, 12,4);
       ObjectSetText( "HILO7", ""+HLo+""  , 12, "Arial Bold", Silver );
}
return(0);
}
//+------------------------------------------------------------------+

int HILO( string Text, int xOffset, int yOffset,int iCorner) //TITLE
{  ObjectCreate(Text,OBJ_LABEL         , 0, 0, 0 );
   ObjectSet   (Text,OBJPROP_CORNER    , iCorner);
   ObjectSet   (Text,OBJPROP_XDISTANCE , 20);
   ObjectSet   (Text,OBJPROP_YDISTANCE , xOffset );
   ObjectSet   (Text,OBJPROP_BACK      , True );
}
int HILO1( string Text, int xOffset, int yOffset,int iCorner) //TITLE
{  ObjectCreate(Text,OBJ_LABEL         , 0, 0, 0 );
   ObjectSet   (Text,OBJPROP_CORNER    , iCorner);
   ObjectSet   (Text,OBJPROP_XDISTANCE , 80);
   ObjectSet   (Text,OBJPROP_YDISTANCE , xOffset );
   ObjectSet   (Text,OBJPROP_BACK      , True );
}
int HILO2( string Text, int xOffset, int yOffset,int iCorner) //TITLE
{  ObjectCreate(Text,OBJ_LABEL         , 0, 0, 0 );
   ObjectSet   (Text,OBJPROP_CORNER    , iCorner);
   ObjectSet   (Text,OBJPROP_XDISTANCE , 20);
   ObjectSet   (Text,OBJPROP_YDISTANCE , xOffset );
   ObjectSet   (Text,OBJPROP_BACK      , True );
}
int HILO3( string Text, int xOffset, int yOffset,int iCorner) //TITLE
{  ObjectCreate(Text,OBJ_LABEL         , 0, 0, 0 );
   ObjectSet   (Text,OBJPROP_CORNER    , iCorner);
   ObjectSet   (Text,OBJPROP_XDISTANCE , 80);
   ObjectSet   (Text,OBJPROP_YDISTANCE , xOffset );
   ObjectSet   (Text,OBJPROP_BACK      , True );
}
int HILO4( string Text, int xOffset, int yOffset,int iCorner) //TITLE
{  ObjectCreate(Text,OBJ_LABEL         , 0, 0, 0 );
   ObjectSet   (Text,OBJPROP_CORNER    , iCorner);
   ObjectSet   (Text,OBJPROP_XDISTANCE , 20);
   ObjectSet   (Text,OBJPROP_YDISTANCE , xOffset );
   ObjectSet   (Text,OBJPROP_BACK      , True );
}
int HILO5( string Text, int xOffset, int yOffset,int iCorner) //TITLE
{  ObjectCreate(Text,OBJ_LABEL         , 0, 0, 0 );
   ObjectSet   (Text,OBJPROP_CORNER    , iCorner);
   ObjectSet   (Text,OBJPROP_XDISTANCE , 80);
   ObjectSet   (Text,OBJPROP_YDISTANCE , xOffset );
   ObjectSet   (Text,OBJPROP_BACK      , True );
}
int HILO6( string Text, int xOffset, int yOffset,int iCorner) //TITLE
{  ObjectCreate(Text,OBJ_LABEL         , 0, 0, 0 );
   ObjectSet   (Text,OBJPROP_CORNER    , iCorner);
   ObjectSet   (Text,OBJPROP_XDISTANCE , 20);
   ObjectSet   (Text,OBJPROP_YDISTANCE , xOffset );
   ObjectSet   (Text,OBJPROP_BACK      , True );
}
int HILO7( string Text, int xOffset, int yOffset,int iCorner) //TITLE
{  ObjectCreate(Text,OBJ_LABEL         , 0, 0, 0 );
   ObjectSet   (Text,OBJPROP_CORNER    , iCorner);
   ObjectSet   (Text,OBJPROP_XDISTANCE , 80);
   ObjectSet   (Text,OBJPROP_YDISTANCE , xOffset );
   ObjectSet   (Text,OBJPROP_BACK      , True );
}